/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT license.
 */
import Alignment from "./alignment";
import BiString, { AnyString } from "./bistring";
import { Replacer } from "./regex";
export default class BiStringBuilder {
    private _original;
    private _modified;
    private _alignment;
    private _oPos;
    private _mPos;
    constructor(original: AnyString);
    get original(): string;
    get current(): string;
    get modified(): string;
    get alignment(): Alignment;
    get position(): number;
    get remaining(): number;
    get isComplete(): boolean;
    peek(n: number): string;
    private _advance;
    skip(n: number): void;
    skipRest(): void;
    insert(str: string): void;
    discard(n: number): void;
    discardRest(): void;
    replace(n: number, str: AnyString): void;
    append(bs: BiString): void;
    private _match;
    private _matchAll;
    skipMatch(pattern: RegExp): boolean;
    discardMatch(pattern: RegExp): boolean;
    replaceMatch(pattern: RegExp, replacement: string | Replacer): boolean;
    replaceAll(pattern: RegExp, replacement: string | Replacer): void;
    build(): BiString;
    rewind(): void;
}
//# sourceMappingURL=builder.d.ts.map